/*
 *	user error codes
 *
 *      Copyright (c) 1984 FairCom
 *	2606 Johnson Drive
 *	Columbia, MO 65201
 *
 *	ALL RIGHTS RESERVED.
 *
 *	c-tree(TM)	Version 4.1
 *			Release C
 *			August 27, 1985 09:59
 *
 *	Unauthorized distribution, adaptation or use may be 
 *	subject to civil and criminal penalties.
 *
 */


                 /* USER ERROR CODES */

#define NO_ERROR	0

#define	KDUP_ERR	2	/* key value already exists */

#define	KMAT_ERR	3	/* could nor delete since pntr's don't match */
#define	KDEL_ERR	4	/* could not find key to delete */
#define	KBLD_ERR	5	/* cannot call delete w/o verification with  */
				/* duplicate keys */

#define SPAC_ERR	10	/* INTREE parameters require too much space */
#define SPRM_ERR	11	/* bad INTREE parameters */
#define FNOP_ERR	12	/* could not open index file */
#define	FUNK_ERR	13	/* unknown file type */
#define FCRP_ERR	14	/* file corrupt at open */
#define FCMP_ERR	15	/* file has been compacted */
#define KCRAT_ERR	16	/* could not create index file */
#define DCRAT_ERR	17	/* could not create data file */
#define KOPN_ERR	18	/* tried to create existing index file */
#define DOPN_ERR	19	/* tried to create existing data file */
#define KMIN_ERR	20	/* key length too large for node size */
#define DREC_ERR	21	/* record length too small */
#define FNUM_ERR	22	/* file number out of range */
#define KMEM_ERR	23	/* illegal index member info */
#define FCLS_ERR	24	/* could not close file */
#define FACS_ERR	26	/* file number not active */
#define ZDRN_ERR	28	/* zero drn in ADDKEY */
#define ZREC_ERR	29	/* zero drn in data file routine */
#define LEOF_ERR	30	/* drn exceeds logical end of file */
#define DELFLG_ERR	31	/* flag not set on record in delete chain */
#define	DDRN_ERR	32	/* attempt to delete record twice in a row */
#define DNUL_ERR	33	/* attempt to use NULL ptr in read/write */
#define PRDS_ERR	34	/* predecessor repeat attempts exhausted */
#define SEEK_ERR	35	/* seek error  */
#define READ_ERR	36	/* read error  */
#define WRITE_ERR	37	/* write error */
#define	VRTO_ERR	38	/* could not convert virtual open to actual */
#define FULL_ERR	39	/* no more records availble */
#define KSIZ_ERR	40	/* key recsiz in OPNIDX too large */
#define UDLK_ERR	41	/* could not unlock data record */
#define DLOK_ERR	42	/* could not obtain data record lock */
#define FVER_ERR	43	/* index file  -  version incompatibility */
#define KLEN_ERR	45	/* key length exceeds MAXLEN parameter    */
#define	FUSE_ERR	46	/* file number already in use.		  */
#define FMOD_ERR	48	/* file mode incompatibility		  */
#define	FSAV_ERR	49	/* could not save file			  */
#define LNOD_ERR	50	/* could not lock node */
#define UNOD_ERR	51	/* could not unlock node */

#define	ICUR_ERR	100	/* no current record for isam datno  */
#define	INOT_ERR	101	/* could not find isam keyno request */
#define INOD_ERR	102	/* could not open ISAM parameter file */
#define IGIN_ERR	103	/* could not read first 5 parameters in ISAM */
				/* parameter file */
#define IFIL_ERR	104	/* too many files in ISAM parameter file */
#define IDRI_ERR	106	/* could not read data file record in ISAM */
				/* parameter file */
#define IDRK_ERR	107	/* too many keys for data file in ISAM */
				/* parameter file */
#define IMKY_ERR	108	/* incorrect keyno for index member in       */
				/* parameter file			     */
#define IKRS_ERR	109	/* too many key segments defined in ISAM */
				/* parameter file */
#define ISRC_ERR	110	/* could not read segment record in ISAM */
				/* parameter file */
#define	IKRI_ERR	111	/* could not read index file record in ISAM */
				/* parameter file */
#define IPND_ERR	112	/* LKISAM(ENABLE) found pending locks	   */
#define INOL_ERR	113	/* no space left in internal lock table    */
#define IRED_ERR	114	/* 1st byte of data record eqauls delete flag */
#define ISLN_ERR	115	/* key segments do not match key length    */
#define IMOD_ERR	116	/* bad isamod parmeter (isam_fil set to isamod) */
#define	IMRI_ERR	117	/* could not read index member record	   */
#define SKEY_ERR	118	/* NXTSET called before FRSSET for keyno   */
#define SKTY_ERR	119	/* FRSSET called for index with wrong keytyp */

#define RRLN_ERR	120	/* data record length exceeds rebuild max  */
#define RSPC_ERR	121	/* not enough space for sort area.	   */
#define RMOD_ERR	122	/* attempt to change fixed vs variable len */
#define	RVHD_ERR	123	/* var length header has bad record mark   */


#define VMAX_ERR	140	/* variable record length too long	*/
#define	VDLK_ERR	146
#define VDLFLG_ERR	147
#define	VLEN_ERR	148
#define	VRLN_ERR	149
#define	VBSZ_ERR	153
#define	VRCL_ERR	154
#define	VFLG_ERR	158
#define	VPNT_ERR	159
#define ITIM_ERR	160	/* multi-user interefernce: index informa-  *
				 * tion updated by the time user got to	    *
				 * actual data record.			    */

/* ******************************************************************** */
/* ************************     end of ct-errc.h    ******************* */
/* ******************************************************************** */
